﻿using System;
using System.Collections.Generic;

using ApplicationBoilerplate.DependencyInjection;
using ApplicationBoilerplate.Events;

using mvcForum.AddOns.Controllers;
using mvcForum.Core.Interfaces;
using mvcForum.Core.Interfaces.AddOns;
using mvcForum.Web.Interfaces;

namespace mvcForum.AddOns.Akismet {

	public class AkismetBuilder : IDependencyBuilder {

		public void Configure(IDependencyContainer container) {
			// 
			container.Register<IAntiSpamAddOn, AkismetAddOn>();
			container.Register<IAddOnConfiguration<AkismetAddOn>, AkismetConfiguration>();
			container.Register<IAntiSpamConfigurationController, AkismetConfigurationController>();

			container.Register<IInstallable, AkismetInstall>();
		}

		public void ValidateRequirements(IList<ApplicationRequirement> feedback) {
		}
	}
}