﻿using System;
using System.Collections.Generic;

using ApplicationBoilerplate.DependencyInjection;
using ApplicationBoilerplate.Events;

using mvcForum.AddOns.Controllers;
using mvcForum.Core.Interfaces;
using mvcForum.Core.Interfaces.AddOns;
using mvcForum.Web.Interfaces;

namespace mvcForum.AddOns.MultiPost {

	public class MultiPostBuilder : IDependencyBuilder {

		public void Configure(IDependencyContainer container) {
			container.Register<IAntiSpamAddOn, MultiPostAddOn>();
			container.Register<IAddOnConfiguration<MultiPostAddOn>, MultiPostConfiguration>();
			container.Register<IAntiSpamConfigurationController, MultiPostConfigurationController>();

			container.Register<IInstallable, MultiPostInstall>();
		}

		public void ValidateRequirements(IList<ApplicationRequirement> feedback) {
		}
	}
}