﻿using System;
using System.Collections.Generic;

using ApplicationBoilerplate.DependencyInjection;
using ApplicationBoilerplate.Events;

using mvcForum.AddOns.Controllers;
using mvcForum.Core.Interfaces;
using mvcForum.Core.Interfaces.AddOns;
using mvcForum.Web.Interfaces;

namespace mvcForum.AddOns.NewUserTrial {

	public class NewUserTrialBuilder : IDependencyBuilder {

		public void Configure(IDependencyContainer container) {
			container.Register<IAntiSpamAddOn, NewUserTrialAddOn>();
			container.Register<IAddOnConfiguration<NewUserTrialAddOn>, NewUserTrialConfiguration>();
			container.Register<IAntiSpamConfigurationController, NewUserTrialConfigurationController>();

			container.Register<IInstallable, NewUserTrialInstall>();
		}

		public void ValidateRequirements(IList<ApplicationRequirement> feedback) {
		}
	}
}
