﻿using System;
using System.Collections.Generic;

using ApplicationBoilerplate.DependencyInjection;
using ApplicationBoilerplate.Events;

using mvcForum.AddOns.Controllers;
using mvcForum.Core.Interfaces;
using mvcForum.Core.Interfaces.AddOns;
using mvcForum.Web.Interfaces;

namespace mvcForum.AddOns.StopForumSpam {

	public class StopForumSpamBuilder : IDependencyBuilder {

		public void Configure(IDependencyContainer container) {
			container.Register<IAntiSpamAddOn, StopForumSpamAddOn>();
			container.Register<IAddOnConfiguration<StopForumSpamAddOn>, StopForumSpamConfiguration>();
			container.Register<IAntiSpamConfigurationController, StopForumSpamConfigurationController>();

			container.Register<IInstallable, StopForumSpamInstall>();
		}

		public void ValidateRequirements(IList<ApplicationRequirement> feedback) { }
	}
}