﻿using System;
using System.Web.Mvc;

using MarkdownSharp;

using mvcForum.Web.Interfaces;

namespace mvcForum.AddOns.ContentParsing {

	public class MarkDownParser : IContentParser {

		public MvcHtmlString Parse(String content) {
			Markdown md = new Markdown(new[] { 
						new MarkDownTag("quote", "<div class=\"ca-bbcode\"><div class=\"ca-bbcode2 ca-quote\"><blockquote><div>", "</div></blockquote></div></div>"),
						new MarkDownTag("paragraph", "", ""),
						new MarkDownTag("code", "<div class=\"ca-bbcode\"><div class=\"ca-bbcode2 ca-code\"><dl class=\"codebox\"><dt>Code:</dt><dd><code>", "</code></dd></dl></div></div>")
					});

			// Let's sanitize the input, we only want allowed HTML-tags to get past the parser and into the output!
			return MvcHtmlString.Create(md.Transform(content.SanitizeHTML(new String[] { "cite" })));
		}

		public String Quote(String author, String content) {
			return String.Format("> <cite>{0} wrote:</cite> {1}", author, content);
		}

		public String Name {
			get {
				return "MarkDown";
			}
		}
	}
}