﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core.Abstractions.Interfaces {

	/// <summary>
	/// Interface for the AccessMask data object
	/// </summary>
	public interface IAccessMaskData : IDataContainer {
		/// <summary>
		/// Name of the access mask.
		/// </summary>
		String Name { get; set; }
		/// <summary>
		/// Id of the Board the AccessMask belongs to.
		/// </summary>
		Int32 BoardId { get; set; }
		/// <summary>
		/// The AccessFlag this AccessMask has.
		/// </summary>
		AccessFlag AccessFlag { get; set; }
	}
}