﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core.Abstractions.Interfaces {

	/// <summary>
	/// Interface for the Adminstration data object
	/// </summary>
	public interface IAdministrationData : IDataContainer {
		/// <summary>
		/// Id of the Board the Administration gives access to.
		/// </summary>
		Int32 BoardId { get; set; }
		/// <summary>
		/// Id of the ForumUser this Administration object contains access for.
		/// </summary>
		Int32 UserId { get; set; }
		/// <summary>
		/// The AdministrationLevel this Administration object gives access to for the given board and user.
		/// </summary>
		AdministrationLevel AdministrationLevel { get; set; }
	}
}