﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core.Abstractions.Interfaces {

	/// <summary>
	/// Interface for the Attachment data object
	/// </summary>
	public interface IAttachmentData : IDataContainer {
		/// <summary>
		/// Filename of the attached file.
		/// </summary>
		String Filename { get; set; }
		/// <summary>
		/// Id of the Post this file is attached to.
		/// </summary>
		Int32 PostId { get; set; }
		/// <summary>
		/// The size of the file, given in bytes.
		/// </summary>
		Int32 Size { get; set; }
		/// <summary>
		/// The number of times this file has been downloaded.
		/// </summary>
		Int32 DownloadCount { get; set; }
		/// <summary>
		/// The path of the file.
		/// </summary>
		String Path { get; set; }
		/// <summary>
		/// Id of the author/owner of the attachment.
		/// </summary>
		Int32 AuthorId { get; set; }
		/// <summary>
		/// Timestamp for when the attachment was created.
		/// </summary>
		DateTime Created { get; set; }
	}
}