﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core.Abstractions.Interfaces {

	/// <summary>
	/// An interfaced used for authored elements (POst, Topic etc).
	/// </summary>
	public interface IAuthoredElement {
		/// <summary>
		/// Author name.
		/// </summary>
		String Author { get; set; }
		/// <summary>
		/// User Id of the author.
		/// </summary>
		Int32 AuthorId { get; set; }
		/// <summary>
		/// The teimstamp for when the element was created.
		/// </summary>
		DateTime Posted { get; set; }
	}
}