﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core.Abstractions.Interfaces {

	/// <summary>
	/// Interface for the Category data object.
	/// </summary>
	public interface ICategoryData : IDataContainer {
		/// <summary>
		/// Name of the category.
		/// </summary>
		String Name { get; set; }
		/// <summary>
		/// Sort order.
		/// </summary>
		Int32 SortOrder { get; set; }
		/// <summary>
		/// Id of the (parent) board.
		/// </summary>
		Int32 BoardId { get; set; }
	}
}