﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace mvcForum.Core {

	/// <summary>
	/// This class represent a board, which is usually the top level shown.
	/// </summary>
	public class Board {
		public Board() { }

		#region Properties
		/// <summary>
		/// The Id of the board.
		/// </summary>
		[Required]
		public Int32 Id { get; set; }
		/// <summary>
		/// The name of the board.
		/// </summary>
		[Required]
		[StringLength(Constants.FieldLengths.BoardName)]
		public String Name { get; set; }
		[StringLength(Int32.MaxValue)]
		public String Description { get; set; }
		[Required]
		public Boolean Disabled { get; set; }
		#endregion

		public virtual ICollection<Category> Categories { get; set; }
	}
}