﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;

namespace mvcForum.Core {

	public static class Constants {

		public static class FieldLengths {
			/// <summary>
			/// Use this constant in the data providers for setting the size of fields containing usernames.
			/// </summary>
			public const Int32 Username = 256;
			/// <summary>
			/// Use this constant in the data providers for setting the size of fields containing subjects.
			/// </summary>
			public const Int32 Subject = 200;
			/// <summary>
			/// Use this constant in the data providers for setting the size of fields containing e-mail addresses.
			/// </summary>
			public const Int32 EmailAddress = 200;
			/// <summary>
			/// Use this constant in the data providers for setting the size of fields containing full-names.
			/// </summary>
			public const Int32 FullName = 200;
			/// <summary>
			/// Use this constant in the data providers for setting the size of fields containing board names.
			/// </summary>
			public const Int32 ProviderName = 50;
			public const Int32 ProviderId = 200;
			public const Int32 BoardName = 200;
			public const Int32 CategoryName = 200;
			public const Int32 ForumName = 200;
			public const Int32 AccessMaskName = 200;
			public const Int32 AttachmentPath = 500;
			public const Int32 AttachmentFilename = 200;
			public const Int32 Password = 100;
			public const Int32 IPAddress = 50;
			public const Int32 CultureInfoId = 10;
			public const Int32 TimezoneId = 100;
			public const Int32 GroupName = 100;
			public const Int32 EditReason = 500;
			public const Int32 DeleteReason = 500;
			public const Int32 ReportReason = 500;
			public const Int32 Title = 200;
			public const Int32 SettingsKey = 100;
			public const Int32 SiteName = 200;
			public const Int32 DefaultLanguage = 10;
			public const Int32 DefaultTimeZone = 100;
			public const Int32 DefaultDateTimeFormat = 50;
			public const Int32 Theme = 200;
		}

		//public static class ActionTypes {
		//    public const String MessageAddedToTopic = "FollowTopic";
		//    public const String TopicAddedToForum = "FollowForum";
		//    public const String AntiSpamTopic = "AntiSpamTopic";
		//    public const String AntiSpamPost = "AntiSpamPost";
		//}

		public static class Roles {
			public const String SolutionAdmin = "Solution Administrator";
			public const String BoardAdmin = "Board Administrator";
			public const String Combined = "Board Administrator,Solution Administrator";
		}
	}
}