﻿using System;

namespace mvcForum.Core {

	public static class DateTimeExtensions {

		public static DateTime Handle(this DateTime dt) {
			if (dt.Kind == DateTimeKind.Unspecified) {
				return new DateTime(dt.Ticks, DateTimeKind.Utc);
			}
			else if (dt.Kind != DateTimeKind.Utc) {
				return TimeZoneInfo.ConvertTimeToUtc(dt);
			}
			return dt;
		}

		public static DateTime? Handle(this DateTime? dt) {
			if (dt.HasValue) {
				if (dt.Value.Kind == DateTimeKind.Unspecified) {
					return new DateTime(dt.Value.Ticks, DateTimeKind.Utc);
				}
				else if (dt.Value.Kind != DateTimeKind.Utc) {
					return TimeZoneInfo.ConvertTimeToUtc(dt.Value);
				}
			}
			return dt;
		}
	}
}