﻿/* mvcForum
 * Copyright (C) 2010-2011 Steen F. Tøttrup
 * http://mvcforum.org/
 */

using System;
using System.ComponentModel.DataAnnotations;

namespace mvcForum.Core {

	/// <summary>
	/// This class represent a Group.
	/// </summary>
	public class Group {
		public Group() { }
		public Group(String name) {
			this.Name = name;
		}

		#region Properties
		/// <summary>
		/// The Id of the group.
		/// </summary>
		public Int32 Id { get; set; }
		/// <summary>
		/// The name of the group.
		/// </summary>
		[StringLength(Constants.FieldLengths.GroupName)]
		[Required]
		public String Name { get; set; }
		#endregion
	}
}