﻿using System;
using System.Linq.Expressions;

using ApplicationBoilerplate.DataProvider;

namespace mvcForum.Core.Specifications {

	public static class AccessMaskSpecifications {

		public class SpecificBoard : ISpecification<AccessMask> {
			private readonly Board board;

			public SpecificBoard(Board board) {
				this.board = board;
			}

			public Expression<Func<AccessMask, Boolean>> IsSatisfied {
				get {
					return x => x.BoardId == board.Id;
				}
			}
		}
	}
}