﻿using System;
using System.Linq.Expressions;

using ApplicationBoilerplate.DataProvider;

namespace mvcForum.Core.Specifications {

	public static class AddOnConfigurationSpecifications {

		public class SpecificKey : ISpecification<AddOnConfiguration> {
			private readonly String key;

			public SpecificKey(String key) {
				this.key = key;
			}

			public Expression<Func<AddOnConfiguration, Boolean>> IsSatisfied {
				get {
					return x => x.Key == key;
				}
			}
		}
	}
}
