﻿using System;
using MongoDB.Driver;
using System.Configuration;

namespace mvcForum.MembershipProviderTest {

	public class MongoConnection {
		protected readonly MongoDatabase database;

		public MongoConnection(String connectionString) {
			MongoUrl url = MongoUrl.Create(connectionString);
			String databaseName = url.DatabaseName;
			MongoClient client = new MongoClient(url);
			MongoServer server = client.GetServer();
			this.database = server.GetDatabase(databaseName);
		}

		public MongoCollection<T> GetCollection<T>() {
			return database.GetCollection<T>(typeof(T).Name.ToLowerInvariant());
		}


		public static MongoConnection Create() {
			return Create("Main.MongoDB");
		}

		public static MongoConnection Create(String name) {
			return new MongoConnection(ConfigurationManager.ConnectionStrings[name].ConnectionString);
		}
	}
}