﻿using System;
using System.ComponentModel.DataAnnotations;

using mvcForum.Core;

namespace mvcForum.Web.Areas.ForumAPI.ViewModels {

	public class Forum {
		public Int32 Id { get; set; }
		[Required(AllowEmptyStrings = false)]
		[StringLength(Constants.FieldLengths.ForumName, MinimumLength = 1)]
		public String Name { get; set; }
		[Required]
		[Range(0, Int32.MaxValue)]
		public Int32 SortOrder { get; set; }
		public String Description { get; set; }

		public Int32? ParentForumId { get; set; }
		public String ParentForumUrl { get; set; }

		public Int32 CategoryId { get; set; }
		public String CategoryUrl { get; set; }
	}
}