﻿using System;
using System.Collections.Generic;

using MVCBootstrap.Web.Mvc.Navigations;

using mvcForum.Core;

namespace mvcForum.Web.Areas.ForumAdmin.Navigations {

	public class AdminTopNavigation : NavigationBase {
		private List<NavigationItem> pages = new List<NavigationItem> {
														new NavigationItem { Controller = "Home", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin, Constants.Roles.BoardAdmin } },
														new NavigationItem { Controller = "Group", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } },
														new NavigationItem { Controller = "User", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } },
														new NavigationItem { Controller = "Settings", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } },
														//new NavigationItem { Controller = "Settings", Action = "UserRegistration", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } },
														new NavigationItem { Controller = "Search", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } },
														new NavigationItem { Controller = "AntiSpam", Action = "Index", Area = "forumadmin", Visible = true, Visibility = PageVisibility.Authenticated, Groups = new String[] { Constants.Roles.SolutionAdmin } }
													};

		protected override IEnumerable<NavigationItem> Items {
			get {
				return pages;
			}
		}

		public override String Name {
			get {
				return "AdminTopNavigation";
			}
		}
	}
}