﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

using mvcForum.Core;
using mvcForum.Web.ViewModels;

namespace mvcForum.Web.Areas.ForumAdmin.ViewModels.Update {

	public class ForumViewModel {

		public ForumViewModel() { }
		public ForumViewModel(Core.Forum forum) {
			this.Id = forum.Id;
			this.Name = forum.Name;
			this.Description = forum.Description;
			this.SortOrder = forum.SortOrder;
		}

		[Required]
		public Int32 Id { get; set; }
		[Required]
		public String Name { get; set; }
		public String Description { get; set; }
		[Required]
		public Int32 SortOrder { get; set; }

		public Dictionary<String, String> Path { get; set; }
		public List<GroupViewModel> Groups { get; set; }
		public List<ForumViewModel> SubForums { get; set; }
		public List<ForumAccessViewModel> ForumAccesses { get; set; }
	}
}