﻿using System;
using MVCBootstrap.Web.Mvc.Attributes;
using mvcForum.Core.Abstractions.Interfaces;

namespace mvcForum.Web.Areas.ForumAdmin.ViewModels.Update {

	public class UserRegistrationViewModel {

		public UserRegistrationViewModel() { }
		public UserRegistrationViewModel(IConfiguration config) {
			this.Editable = config.Editable;
			this.UseForumAccountController = config.UseForumAccountController;
			this.AllowLocalUsers = config.AllowLocalUsers;
			this.AllowSignUp = config.AllowSignUp;
			this.RequireEmailValidation = config.RequireEmailValidation;
			this.AllowOpenAuthUsers = config.AllowOpenAuthUsers;
			this.ValidationSubject = config.ValidationSubject;
			this.ValidationBody = config.ValidationBody;
			this.RequireRulesAccept = config.RequireRulesAccept;
			this.SignUpRules = config.SignUpRules;
		}

		public Boolean Editable { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "UseForumAccountController")]
		public Boolean UseForumAccountController { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "AllowLocalUsers")]
		public Boolean AllowLocalUsers { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "AllowSignUp")]
		public Boolean AllowSignUp { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "RequireEmailValidation")]
		public Boolean RequireEmailValidation { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "AllowOpenAuthUsers")]
		public Boolean AllowOpenAuthUsers { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "ValidationSubject")]
		public String ValidationSubject { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "ValidationBody")]
		public String ValidationBody { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "RequireRulesAccept")]
		public Boolean RequireRulesAccept { get; set; }
		[LocalizedDisplay("MVCForum.Web.ViewModels.UserRegistrationViewModel", "SignUpRules")]
		public String SignUpRules { get; set; }
	}
}