﻿using System;
using System.Web.Mvc;

using MVCThemes.Interfaces;

namespace mvcForum.Web.Extensions {

	public static class UrlHelperExtensions {

		private static String GetTheme() {
			// Get the theme provider!
			IThemeProvider provider = DependencyResolver.Current.GetService<IThemeProvider>();
			// Did we get one?
			if (provider != null) {
				// Yes, let's get the theme then!
				return provider.GetTheme();
			}
			return String.Empty;
		}

		public static String GetThemeBaseUrl(this UrlHelper url) {
			String theme = GetTheme();
			if (!String.IsNullOrWhiteSpace(theme)) {
				// Let's build the URL then!
				return String.Format("/themes/{0}/", theme);
			}
			// No dice, let's just return the usual views base path.
			return "/";
		}
	}
}