﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;

using mvcForum.Core;

namespace mvcForum.Web.ViewModels {

	public class BoardViewModel : ForumViewModelBase {

		public BoardViewModel() : base() { }
		public BoardViewModel(Board board) : base() {
			this.Id = board.Id;
			this.Name = board.Name;
			this.Description = board.Description;
		}

		public Int32 Id { get; set; }
		[Required]
		public String Name { get; set; }
		public String Description { get; set; }

		public ReadOnlyCollection<AccessMaskViewModel> AccessMasks { get; set; }
		public ReadOnlyCollection<CategoryViewModel> Categories { get; set; }
		//public Dictionary<String, String> Path { get; set; }

		public Boolean ShowOnline { get; set; }
		public IEnumerable<ForumUser> OnlineUsers { get; set; }
	}
}