﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

using MVCBootstrap.Web.Mvc.Attributes;

using mvcForum.Core;

namespace mvcForum.Web.ViewModels.Update {

	public class UpdateMessageViewModel : ForumViewModelBase {
		[Required]
		public Int32 Id { get; set; }
		[AllowHtml]
		[Required]
		[LocalizedDisplay("mvcForum.Web.UpdateMessage","Message")]
		public String Body { get; set; }
		[Required]
		[LocalizedDisplay("mvcForum.Web.UpdateMessage", "Subject")]
		public String Subject { get; set; }
		[LocalizedDisplay("mvcForum.Web.UpdateMessage", "AttachFile")]
		public Boolean AttachFile { get; set; }
		[LocalizedDisplay("mvcForum.Web.UpdateMessage", "Flag")]
		public PostFlag Flag { get; set; }
		[LocalizedDisplay("mvcForum.Web.UpdateMessage", "Reason")]
		public String Reason { get; set; }

		public String TopicTitle { get; set; }
		public Int32 TopicId { get; set; }
		public Boolean IsModerator { get; set; }
	}
}