﻿using System;

using mvcForum.Core;
using System.ComponentModel.DataAnnotations;
using MVCBootstrap.Web.Mvc.Attributes;

namespace mvcForum.Web.ViewModels.Update {

	public class UpdateUserViewModel {

		public UpdateUserViewModel() : base() { }

		public UpdateUserViewModel(ForumUser user, Boolean external)
			: base() {

			this.Culture = user.Culture;
			this.Timezone = user.Timezone;
			this.FullName = user.FullName;
			this.Name = user.Name;
			this.Email = user.EmailAddress.EndsWith("repl@ce.this") ? "" : user.EmailAddress;
			this.Id = user.Id;
			this.ExternalUser = external;
		}

		[Required]
		public Int32 Id { get; set; }
		[Required]
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "Culture")]
		public String Culture { get; set; }
		[Required]
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "Timezone")]
		public String Timezone { get; set; }
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "FullName")]
		public String FullName { get; set; }
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "Name")]
		public String Name { get; private set; }
		[Required]
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "Email")]
		public String Email { get; set; }
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "OldPassword")]
		public String OldPassword { get; set; }
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "NewPassword")]
		public String NewPassword { get; set; }
		[LocalizedDisplay(typeof(mvcForum.Web.ViewModels.Update.UpdateUserViewModel), "RepeatNewPassword")]
		public String RepeatedNewPassword { get; set; }

		public Boolean ExternalUser { get; private set; }
	}
}