﻿using System;
using System.Collections.Generic;

using MVCBootstrap.Web.Mvc.Navigations;

namespace mvcForum.WebUI.Intrastructure {

	public class TopNavigation : NavigationBase {
		private List<NavigationItem> pages = new List<NavigationItem> {
														new NavigationItem { Controller = "Home", Action = "Index", Visible = true, Visibility = PageVisibility.Always },
														new NavigationItem { Controller = "Home", Action = "Index", Area = "Forum", Visible = true, Visibility = PageVisibility.Always },
														new NavigationItem { Controller = "Home", Action = "Index", Area = "ForumAdmin", Visible = true, Visibility = PageVisibility.Authenticated },
														new NavigationItem { Controller = "Profile", Action = "Update", Area = "Forum", Visible = true, Visibility = PageVisibility.Authenticated },
														new NavigationItem { Controller = "Account", Action = "LogOn", Area = "Forum", Visible = true, Visibility = PageVisibility.Anonymous },
														new NavigationItem { Controller = "Account", Action = "Register", Area = "Forum", Visible = true, Visibility = PageVisibility.Anonymous },
														new NavigationItem { Controller = "Account", Action = "LogOff", Area = "Forum", Visible = true, Visibility = PageVisibility.Authenticated }
													};

		protected override IEnumerable<NavigationItem> Items {
			get {
				return this.pages;
			}
		}

		public override string Name {
			get {
				return "TopNavigation";
			}
		}
	}
}